export default class MenuHandler {
  constructor(settings) {
    this.settings = settings;
    this.handleParentHover = this.handleParentHover.bind(this);

    const parents = document.querySelectorAll(settings.parentSelector);
    [ ...parents ].forEach(this.handleParentHover);
  }

  handleParentHover(parent) {
    const child = parent.querySelector(this.settings.submenuSelector);

    if (!child) {
      return;
    }

    const toggle = () => child.classList.toggle('visible');
    const childLinks = child.querySelectorAll('a');

    parent.addEventListener('mouseenter', toggle);
    parent.addEventListener('mouseleave', toggle);

    if (!childLinks) {
      return;
    }

    const handleChildLinkFocus = childLink => {
      childLink.addEventListener('focusin', toggle);
      childLink.addEventListener('focusout', toggle);
    };

    childLinks.forEach(handleChildLinkFocus);
  }
}
